using Formatting


directions = Dict("vx" => "~{} ~ ~", "vy" => "~ ~{} ~", "vz" => "~ ~ ~{}")

unit = 10000

max = fld(unit, 2)

epsilon = 40


function searchfile(l, u)
	open(joinpath(path, "_search/search_$(l)_$(u).mcfunction"), "w") do f
		
		mid = fld(l + u, 2)
		
		if u - l + 1 <= epsilon
			write(f, """
				scoreboard players operation @s tmp1 = @s in1
				scoreboard players remove @s tmp1 $(abs(mid))
				
				function movement:_movement/mvt_vx_$(l)_$(u) if @s[score_in3_min=1,score_in3=1]
				function movement:_movement/mvt_vy_$(l)_$(u) if @s[score_in3_min=2,score_in3=2]
				function movement:_movement/mvt_vz_$(l)_$(u) if @s[score_in3_min=3,score_in3=3]
				function movement:_movement/mvt_vx_-$(u)_-$(l) if @s[score_in3_min=-1,score_in3=-1]
				function movement:_movement/mvt_vy_-$(u)_-$(l) if @s[score_in3_min=-2,score_in3=-2]
				function movement:_movement/mvt_vz_-$(u)_-$(l) if @s[score_in3_min=-3,score_in3=-3]
				""")
				
				
			for dir in ("vx", "vy", "vz")
				mvtfile(dir, l, u)
				mvtfile(dir, -u, -l)
			end
	
		else
			write(f, """
				function movement:_search/search_$(l)_$(mid) if @s[$( l > -max ? "score_in1_min=$l," : "" )score_in1=$mid]
				function movement:_search/search_$(mid+1)_$(u) if @s[score_in1_min=$(mid + 1)$( u < max ? ",score_in1=$u" : "")]
				""")
			
			searchfile(l, mid)
			searchfile(mid + 1, u)
		end
	end
end
				

				
function mvtfile(dir, l, u)
	open(joinpath(path, "_movement/mvt_$(dir)_$(l)_$(u).mcfunction"), "w") do f
	
		mid = fld(l + u, 2)
		
		write(f, """
			execute @s ~ ~ ~ teleport @s $( format(directions[dir], mid / unit) )
			scoreboard players remove @s in2 1
			scoreboard players operation @s err_$dir $(mid > 0 ? '+' : '-')= @s tmp1
			function movement:_movement/mvt_$(dir)_$(l)_$(u) if @s[score_in2_min=1]
			""")
	end
end


path = length(ARGS) > 0 ? ARGS[1] : "."


searchfile(1, max)

