#############################
#
# Compute e^x assuming x >= 0
# 
# Input:
#	in1: x in the U format
#
#
# Computes e^x using an iterative method:
# 	x[n+1] = x[n] + (2*n + 1 + x) * x^(2*n) / (2*n + 1)!
#
#
# RMSD: 8.45 * 10^(-6) (for x <= 15. e^15 ~= 3.3 * 10^10)
#
# Made by Arth2000
#
#############################


scoreboard players operation @s tmp1 = @s in1
scoreboard players operation @s tmp1 /= 2*U/3 CONST
scoreboard players add @s tmp1 2

# in2 = 2 * n + 1 + x
scoreboard players operation @s in2 = @s tmp1
scoreboard players operation @s in2 += @s tmp1
scoreboard players add @s in2 1

# in3 = 2 * n + 1
scoreboard players operation @s in3 = @s in2
scoreboard players operation @s in2 *= U CONST
scoreboard players operation @s in2 += @s in1

# in1 = x^2
scoreboard players operation @s in1 *= @s in1
scoreboard players add @s in1 5000
scoreboard players operation @s in1 /= U CONST

scoreboard players set @s out1 0

function utils:math/exp/iterexp_iter
