#############################
#
# Compute the sin of in1 using a 3rd order approx
# Assume -10000 <= in1 <= 10000
# sin(pi/2 x) ~= (7/4 + 105/pi^2 - 1260/pi^4) x^3 + (1260/pi^4 - 105/pi^2 - 3/4) x
# 
# a = (7/4 + 105/pi^2 - 1260/pi^4)
# b = (1260/pi^4 - 105/pi^2 - 3/4)
#
# in1  in 10000
# out1 in 10000
#
# in1 = 2/pi * x * 10000 = d / 90 * 10000 = z * 10000
#	where x is the angle in radians and d the angle in degrees
#
#
# RMSD: 3.98 * 10^(-3)
#
#
# Made by Arth2000
#
#############################

# Let z = 2/pi * x
# Let m = 137766
# Let u = 10000
# out1 = ( (a * m * z * u + u/2) / u * z * u + b * m * u + u/2) / u * z * u / m

# a * 137766
scoreboard players set @s out1 -75277
scoreboard players operation @s out1 *= @s in1
scoreboard players operation @s out1 /= U CONST
scoreboard players operation @s out1 *= @s in1
scoreboard players add @s out1 5000

# b * 137766 * U
scoreboard players add @s out1 2130436827
scoreboard players operation @s out1 /= U CONST

scoreboard players operation @s out1 *= @s in1
scoreboard players operation @s out1 /= sin3_f3 CONST

scoreboard players set @s[score_out1_min=10001] out1 10000
scoreboard players set @s[score_out1=-10001] out1 -10000
